#ifndef LINECYLN_H
#define LINECYLN_H

typedef struct
{
    float x, y, z;
}
Point3;

typedef struct
{
    // line is origin+t*direction (direction is unit length)
    Point3 origin;
    Point3 direction;
}
Line3;

typedef struct
{
    // cylinder radius is measured perpendicular to axis
    Line3 axis;
    float radius;
}
Cylinder3;

void IntersectLineCylinder (const Line3& line, const Cylinder3& cylinder,
    int& numIntersections, Point3 intersection[2]);

#endif
