Attribute VB_Name = "intersection"
Global Const EPSILON = 0.000001

'---------------------------------------------------------------------------
' Point en 3D
'---------------------------------------------------------------------------
Public Type Point3
    X As Double
    Y As Double
    Z As Double
End Type

'---------------------------------------------------------------------------
' Line en 3D
'---------------------------------------------------------------------------
Public Type Line3
    origin As Point3
    Direction As Point3
End Type

'---------------------------------------------------------------------------
' Cylindre en 3D
'---------------------------------------------------------------------------
Public Type Cylinder3
   axis As Line3
   radius As Double
End Type
    
'Produit vectoriel
Function VecProd(P1 As Point3, P2 As Point3) As Point3
Dim P4 As Point3

 P4.X = (P1.Y * P2.Z) - (P1.Z * P2.Y)
 P4.Y = (P1.Z * P2.X) - (P1.X * P2.Z)
 P4.Z = (P1.X * P2.Y) - (P1.Y * P2.X)
 VecProd = P4
 
End Function

'Produit Scalaire
Function Dot(P As Point3, Q As Point3) As Double
    Dot = P.X * Q.X + P.Y * Q.Y + P.Z * Q.Z
End Function

'Ajout de vecteur
Function VecAdd(P1 As Point3, P2 As Point3, Optional F As Double = 1) As Point3
 Dim P3 As Point3
 P3.X = P1.X + F * P2.X
 P3.Y = P1.Y + F * P2.Y
 P3.Z = P1.Z + F * P2.Z
 VecAdd = P3
End Function

' Soustraction de vecteur
Function VecSub(P1 As Point3, P2 As Point3) As Point3
 VecSub.X = P1.X - P2.X
 VecSub.Y = P1.Y - P2.Y
 VecSub.Z = P1.Z - P2.Z
End Function

Function Longueur(ByRef P1 As Point3) As Double
  Longueur = Sqr((P1.X ^ 2) + (P1.Y ^ 2) + (P1.Z ^ 2))
End Function
' transforme un vecteur en vecteur unitaire
Function VecteurUnitaire(ByRef P1 As Point3) As Point3
Dim Norm As Double
Norm = Sqr((P1.X) ^ 2 + (P1.Y) ^ 2 + (P1.Z) ^ 2)
If Norm = 0 Then
    Exit Function
End If
    
    VecteurUnitaire.X = P1.X / Norm
    VecteurUnitaire.Y = P1.Y / Norm
    VecteurUnitaire.Z = P1.Z / Norm
End Function

'----------------------------------------------------------------------------
' Calcul L'intersection d'un cylindre est d'une ligne
' Le code d'origine est une source C trouv sur le NET
' J'ai pas mal modifi le code
' J'ai laiss les explications d'origine en Anglais
' Pour simplifi le code l'origine du cylindre est ramene au point 0,0,0
' j'ai donc une translation de l'origine de la ligne
' J'ai rajout aussi un teste final pour savoir si le point d'intersection est dans la partie
' Du cylindre dfinis entre les deux points de son axe ( DOT >=0 et DOT > 0 )
'----------------------------------------------------------------------------
' General quadric equation is X^T A X + B^T X + C = 0 where A is a 3x3
' symmetric matrix, B is a 3x1 vector, and C is a scalar.  X is a 3x1
' vector of unknowns.  Factor A = R^T D R using an eigendecomposition
' where R is an orthonormal matrix and D = diag(d0,d1,d2) is a diagonal
' matrix.  Define E = RB and Y = RX.  The quadric becomes
'
'   Y^T D Y + E^T Y + C = 0
'
' Let Y = (y0,y1,y2) and E = (e0,e1,e2).  If d0 = d1 = 1 and d2 = 0 and
' e2 = 0, the equation describes a cylinder.  The last row of R is the
' cylinder axis (last row corresponds to eigenvalue d2 = 0).  Completing
' the square yields
'
'   (y0+0.5*e0)^2 + (y1+0.5*e1)^2 = 0.25*(e0^2+e1^2) - C.
'
' If the right-hand side is positive, then the cylinder squared radius
' is the right-hand side.  A point on the cylinder axis is -(e0,e1,0)/2
' = -E/2, where the components are in the Y coordinate system.  In the
' original X coordinates, the point is P = -R^T E/2.  The direction of
' the cylinder axis is (0,0,1) in the Y coordinate system.  In the X
' coordinate system, the axis is F = R^T (0,0,1) (the last row of R).
'
'
' The reverse problem is to specify the cylinder axis P+t*F and radius
' r, then compute the corresponding quadric equation X^T A X + B^T X + C
' = 0.  Choose vectors U and V so that U, V, and F form an orthonormal
' set.  Transpose of orthogonal matrix is R^T = (U V F) where U, V, and
' F are the columns of the matrix.  Diagonal matrix is D = diag(1,1,0).
' E = -2*R*P implies B = R^T E = -2*P.  Matrix A = R^T D R.  Finally,
' r^2 = 0.25*(e0^2+e1^2)-C implies C = 0.25*(e0^2+e1^2)-r^2.
'
'
' Given a line X(t) = Q+t*G and quadric equation X^T A X + B^T X + C = 0,
' plug in X(t) to get
'
'   (G^T A G) t^2 + (B^T G + 2 Q^T A G) t + (Q^T A Q + B^T Q + C) = 0.
'
' or c0+c1*t+c2*t^2.  Solve for t.  If two distinct real roots, line
' intersects cylinder in two points.  If one repeated real root, line
' is tangent to cylinder.  If no real roots, line and cylinder do not
' intersect.

'---------------------------------------------------------------------------
Sub IntersectLineCylinder(line As Line3, OrigineCylindre As Point3, SommetCylindre As Point3, Rayon As Double, numIntersections As Integer, intersection() As Point3)
ReDim intersection(2) As Point3

    ' choose U, V so that U,V,F is orthonormal set
Dim U As Point3
Dim V As Point3
'Dim F As Point3

Dim P As Point3
Dim B As Point3

Dim discr As Double
Dim length As Double
Dim invLength As Double
Dim prod As Double
Dim R(2, 2) As Double
Dim A(2, 2) As Double
Dim invC2   As Double
Dim root0  As Double
Dim root1  As Double
        
Dim root As Double

Dim e0  As Double
Dim e1 As Double
Dim C As Double

Dim c2 As Double
Dim c1 As Double
Dim c0 As Double

Dim AG As Point3
Dim AQ As Point3

Dim Q As Point3
Dim G As Point3

Dim DirectionCylindre As Point3
Dim AxeCylindre As Point3

Dim D1 As Double
Dim D2 As Double

Dim P_Intersection As Point3


On Error GoTo fin

'transformation
AxeCylindre = VecSub(SommetCylindre, OrigineCylindre)
DirectionCylindre = VecteurUnitaire(AxeCylindre)

If Longueur(VecProd(line.Direction, DirectionCylindre)) = 0 Then
    MsgBox "vecteur nul ou parrallele"
    
    GoTo fin
End If

     'F = cylinder.axis.Direction
     
    If (Abs(DirectionCylindre.X) > Abs(DirectionCylindre.Y)) And (Abs(DirectionCylindre.X) > Abs(DirectionCylindre.Z)) Then

        length = Sqr(DirectionCylindre.X * DirectionCylindre.X + DirectionCylindre.Y * DirectionCylindre.Y)
        'invLength = 1 / length
        U.X = -DirectionCylindre.Y / length
        U.Y = DirectionCylindre.X / length
        U.Z = 0
        prod = -DirectionCylindre.Z / length
        V.X = DirectionCylindre.X * prod
        V.Y = DirectionCylindre.Y * prod
        V.Z = length

    Else
        length = Sqr(DirectionCylindre.Y * DirectionCylindre.Y + DirectionCylindre.Z * DirectionCylindre.Z)
        'invLength = 1 / length
        U.X = 0
        U.Y = -DirectionCylindre.Z / length
        U.Z = DirectionCylindre.Y / length
        prod = -DirectionCylindre.X / length
        V.X = length
        V.Y = DirectionCylindre.Y * prod
        V.Z = DirectionCylindre.Z * prod
   End If

    ' orthonormal matrix
    ' R(3,3) =
    R(0, 0) = U.X
    R(0, 1) = U.Y
    R(0, 2) = U.Z
    
    R(1, 0) = V.X
    R(1, 1) = V.Y
    R(1, 2) = V.Z
    
    R(2, 0) = DirectionCylindre.X
    R(2, 1) = DirectionCylindre.Y
    R(2, 2) = DirectionCylindre.Z
    

    ' matrix A
    ' A(3,3) =
    A(0, 0) = R(0, 0) * R(0, 0) + R(1, 0) * R(1, 0)
    A(0, 1) = R(0, 0) * R(0, 1) + R(1, 0) * R(1, 1)
    A(0, 2) = R(0, 0) * R(0, 2) + R(1, 0) * R(1, 2)
   '
    A(1, 0) = R(0, 1) * R(0, 0) + R(1, 1) * R(1, 0)
    A(1, 1) = R(0, 1) * R(0, 1) + R(1, 1) * R(1, 1)
    A(1, 2) = R(0, 1) * R(0, 2) + R(1, 1) * R(1, 2)
    '
    A(2, 0) = R(0, 2) * R(0, 0) + R(1, 2) * R(1, 0)
    A(2, 1) = R(0, 2) * R(0, 1) + R(1, 2) * R(1, 1)
    A(2, 2) = R(0, 2) * R(0, 2) + R(1, 2) * R(1, 2)


    ' vector B
    'P = cylinder.axis.origin
    'B.X = -2 * P.X
    'B.Y = -2 * P.Y
    'B.Z = -2 * P.Z

    ' constant C
     'e0 = -2 * (R(0, 0) * P.X + R(0, 1) * P.Y + R(0, 2) * P.Z)
     'e1 = -2 * (R(1, 0) * P.X + R(1, 1) * P.Y + R(1, 2) * P.Z)
     'C = 0.25 * (e0 * e0 + e1 * e1) - (cylinder.radius * cylinder.radius)
     C = -(Rayon * Rayon)
     
    ' line
     Q = VecSub(line.origin, OrigineCylindre)
     G = line.Direction

    ' compute A*G
     AG.X = A(0, 0) * G.X + A(0, 1) * G.Y + A(0, 2) * G.Z
     AG.Y = A(1, 0) * G.X + A(1, 1) * G.Y + A(1, 2) * G.Z
     AG.Z = A(2, 0) * G.X + A(2, 1) * G.Y + A(2, 2) * G.Z


    ' compute A*Q
    AQ.X = A(0, 0) * Q.X + A(0, 1) * Q.Y + A(0, 2) * Q.Z
    AQ.Y = A(1, 0) * Q.X + A(1, 1) * Q.Y + A(1, 2) * Q.Z
    AQ.Z = A(2, 0) * Q.X + A(2, 1) * Q.Y + A(2, 2) * Q.Z

    ' compute quadratic equation c0+c1*t+c2*t^2 = 0
     'c2 = G.X * AG.X + G.Y * AG.Y + G.Z * AG.Z
     'c1 = (B.X * G.X + B.Y * G.Y + B.Z * G.Z) + 2 * (Q.X * AG.X + Q.Y * AG.Y + Q.Z * AG.Z)
     'c0 = Q.X * AQ.X + Q.Y * AQ.Y + Q.Z * AQ.Z + B.X * Q.X + B.Y * Q.Y + B.Z * Q.Z + C

     c2 = G.X * AG.X + G.Y * AG.Y + G.Z * AG.Z
     c1 = 2 * (Q.X * AG.X + Q.Y * AG.Y + Q.Z * AG.Z)
     c0 = Q.X * AQ.X + Q.Y * AQ.Y + Q.Z * AQ.Z + C
     
    ' solve for intersections
    'const float epsilon = 1e-06f
    discr = c1 * c1 - 4 * (c0 * c2)
    'numIntersections = 0
        If (discr > EPSILON) Then
    
            'numIntersections = 2
            discr = Sqr(discr)
            'invC2 = 1 / c2
            root0 = -0.5 * (c1 + discr) / c2
            root1 = -0.5 * (c1 - discr) / c2
            
            
            P_Intersection.X = Q.X + root0 * G.X + OrigineCylindre.X
            P_Intersection.Y = Q.Y + root0 * G.Y + OrigineCylindre.Y
            P_Intersection.Z = Q.Z + root0 * G.Z + OrigineCylindre.Z
            
            'control que le point est sur le cylindre
             D1 = Dot(VecSub(P_Intersection, OrigineCylindre), AxeCylindre)
             D2 = Dot(VecSub(P_Intersection, SommetCylindre), VecSub(OrigineCylindre, SommetCylindre))
            
             If D1 >= 0 And D2 >= 0 Then
                    intersection(numIntersections) = P_Intersection
                    numIntersections = numIntersections + 1
             End If
     
                
            'Deuxime point
            P_Intersection.X = Q.X + root1 * G.X + OrigineCylindre.X
            P_Intersection.Y = Q.Y + root1 * G.Y + OrigineCylindre.Y
            P_Intersection.Z = Q.Z + root1 * G.Z + OrigineCylindre.Z
    
             'control que le point est sur le cylindre
             D1 = Dot(VecSub(P_Intersection, OrigineCylindre), AxeCylindre)
             D2 = Dot(VecSub(P_Intersection, SommetCylindre), VecSub(OrigineCylindre, SommetCylindre))
            
             If D1 >= 0 And D2 >= 0 Then
                    intersection(numIntersections) = P_Intersection
                    numIntersections = numIntersections + 1
             End If
            
        Else
             If (discr < -EPSILON) Then
                    numIntersections = 0
       
             Else
                'numIntersections = 1
                root = -0.5 * c1 / c2
                
                P_Intersection.X = Q.X + root * G.X + OrigineCylindre.X
                P_Intersection.Y = Q.Y + root * G.Y + OrigineCylindre.Y
                P_Intersection.Z = Q.Z + root * G.Z + OrigineCylindre.Z
    
             'control que le point est sur le cylindre
             D1 = Dot(VecSub(P_Intersection, OrigineCylindre), AxeCylindre)
             D2 = Dot(VecSub(P_Intersection, SommetCylindre), VecSub(OrigineCylindre, SommetCylindre))
             
              If D1 >= 0 And D2 >= 0 Then
                    intersection(numIntersections) = P_Intersection
                    numIntersections = numIntersections + 1
             End If
             
            End If
    End If
    Exit Sub
    
fin:
    numIntersections = 0
End Sub
'---------------------------------------------------------------------------




